/* D/A

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0  2 May 2003 by Reed Lai
    Identify target... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "ixisa.h"

int main()
{
	int fd;
	char *dev_file;
	ixisa_reg_t reg, rai;
	float ao;

	dev_file = "/dev/ixisa1";

	/* open device file */
	fd = open(dev_file, O_RDWR);
	if (fd < 0) {
		printf("Failure of open device file \"%s.\"\n", dev_file);
		return FAILURE;
	}

	/* Select Chanel 0 */
	reg.id = IXISA_AO0;	
	/* Unipolar, Internal Reference -5V, and Output 2.5V */
	ao = 3.5;
	reg.value = (ao * 0xfff / 5);
	if (ioctl(fd, IXISA_WRITE_REG, &reg)) {
		printf("Failure of ioctl command IXISA_WRITE_REG IXISA_AO0.\n");
		close(fd);
		return FAILURE;
	}

	printf("Output = %x, %fV\n", reg.value, ao);
	getchar();
	close(fd);
	return SUCCESS;
}
