/* File level history (record changes for this file here.)
 *
 *    v 0.1.0 2 Aug 2013 by Winson Chen
 *    	Analog output between -10V~10V
*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "ixisa.h"
#include"_isoda16.h"

int wait_status(int in_status,int fd)
{
	long t = 0;
        ixisa_reg_t rao;
	while(t <100000){
		rao.id = IXISA_SR;
		ioctl(fd,IXISA_READ_REG ,&rao);
		rao.value = rao.value & 0x07;
		if(rao.value != in_status)
			t++;
		else{
    			rao.id = IXISA_SR;
      			ioctl(fd,IXISA_READ_REG,&rao);

    			rao.id = IXISA_SR;
      			ioctl(fd,IXISA_READ_REG,&rao);
			return(NoError);
		}
	}
	return(TimeOut);
}

int main()
{
	int Max[16] = {16294,16296,16294,16295,16297,16297,16296,16295,16297,16298,16299,16296,16297,16302,16296,16296};
	int Min[16] = {134,132,134,134,137,136,138,135,135,131,136,135,133,127,134,132};
	float Delta[16] = {0}, voltage = 0;

        int fd,i;
        char *dev_file;
	int wChannel ,wValue;  /* 10V after calibrate */
	int arg1,arg2,command;
        ixisa_reg_t rao;

        dev_file = "/dev/ixisa1";

        /* open device file */
        fd = open(dev_file, O_RDWR);
        if (fd < 0) {
                printf("Failure of open device file \"%s.\"\n", dev_file);
                return FAILURE;
        }

	printf("Please enter channel and voltage:");
	scanf("%d %f",&wChannel,&voltage);

	for(i = 0;i < 16;i++)
        {
                Delta[i] = 20.0 / (Max[i]-Min[i]);
        }

	wValue = (voltage+10.0) / Delta[wChannel] + Min[wChannel];
	rao.id = IXISA_SR;
        rao.value = 0;
        if (ioctl(fd, IXISA_READ_REG, &rao)){
                printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
                close(fd);
                return FAILURE;
        }

	if(rao.value & 0x02 != 1){
        	rao.id = IXISA_RWCR;
        	if (ioctl(fd, IXISA_READ_REG, &rao)){
               		printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
                	close(fd);
                	return FAILURE;
        	}
	}

	command = WRITE_DA_0 + wChannel / 4;
	arg1 = wChannel % 4;
	arg1 = arg1 * 64 + wValue / 256;
	arg2 = wValue % 256;

	if(wait_status(WRITE_READY,fd)==TimeOut)return(TimeOut);
	rao.value = command & 0x0ff;
	rao.id = IXISA_RWCR;
	if (ioctl(fd, IXISA_WRITE_REG, &rao)){
		printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
		close(fd);
		return FAILURE;
	}

        if(wait_status(WRITE_READY,fd)==TimeOut)return(TimeOut);
	rao.value = arg1 & 0x0ff;
        rao.id = IXISA_RWCR;
        if (ioctl(fd, IXISA_WRITE_REG, &rao))
        {
                printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
                close(fd);
                return FAILURE;
        }

        if(wait_status(WRITE_READY,fd)==TimeOut)return(TimeOut);
	rao.value = arg2 & 0x0ff;
        rao.id = IXISA_RWCR;
        if (ioctl(fd, IXISA_WRITE_REG, &rao))
        {
                printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
                close(fd);
                return FAILURE;
        }

	rao.id = IXISA_RWCR;
        if (ioctl(fd, IXISA_READ_REG, &rao))
        {
                printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_AO.\n");
                close(fd);
                return FAILURE;
        }
	printf("The channel %d, Voltage is %.2f\n",wChannel,voltage);

        close(fd);
        return SUCCESS;
}
                                                                   
