/* Read/write register by ioctl command IXISA_READ_REG and IXISA_WRITE_REG for
   digital I/O.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0 11 Apr 2003 by Reed Lai
     I do this for Aiur! */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "ixisa.h"

int main()
{
	int fd;
	char *dev_file;
	ixisa_reg_t rdi, rdo;

	dev_file = "/dev/ixisa1";

	/* open device file */
	fd = open(dev_file, O_RDWR);
	if (fd < 0) {
		printf("Failure of open device file \"%s.\"\n", dev_file);
		return FAILURE;
	}

	/* set D/O output latch ports are enable */
	rdo.id = IXISA_SR;
	rdo.value = 1;
	ioctl(fd, IXISA_WRITE_REG, &rdo);
	
	/* DIO */
	rdo.value = 0;

	puts("Enter to continue, ESC to exit.");
	while (getchar() != 27) {
		rdo.id = IXISA_DOL;
		if (ioctl(fd, IXISA_WRITE_REG, &rdo)) {
			/* DO */
			printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_DO.\n");
			close(fd);
			return FAILURE;
		}
		printf("DOL = 0x%x\t", rdo.value);
		
		rdo.id = IXISA_DOH;
		if (ioctl(fd, IXISA_WRITE_REG, &rdo)) {
			/* DO */
			printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_DO.\n");
			close(fd);
			return FAILURE;
		}
		printf("DOH = 0x%x\t", rdo.value);
		
		rdi.id = IXISA_DIL;
		if (ioctl(fd, IXISA_READ_REG, &rdi)) {
			/* DI */
			printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_DI.\n");
			close(fd);
			return FAILURE;
		}
		printf("DIL = 0x%x\t", rdi.value);

		rdi.id = IXISA_DIH;
		if (ioctl(fd, IXISA_READ_REG, &rdi)) {
			/* DI */
			printf ("Failure of ioctl command IXISA_WRITE_REG IXISA_IXISA_DI.\n");
			close(fd);
			return FAILURE;
		}
		printf("DIH = 0x%x\t", rdi.value);

		rdo.value > 0xfff ? rdo.value = 0 : ++(rdo.value);
	}

	close(fd);
	return SUCCESS;
}
