//--------------------------------------------------------
// DEMO2.cpp                                    2/25/2001
//                   
// CPU version 2.0
//
// Function:
//    test WAIT_X_STOP(),WAIT_IS_X_STOP()
//    round robin test
//--------------------------------------------------------
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
//#include <conio.h>
//#include <dos.h>
//#include <bios.h>
//#include "mservo3.h"
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include "msw-mservo3.h"

//----- define --------------------------------------------
#define CARD1 0

//----- structure -----------------------------------------
typedef struct
  {
         //---- parameter ---------
         unsigned int  address;
         unsigned char exist;
         unsigned char DDA;
         unsigned char AD;
         unsigned int  LSP;
         unsigned int  HSP;
         unsigned char home_speed;
         unsigned char search_speed;
         unsigned int  arc_speed;
         unsigned char in_position;
         unsigned int  lag_error; 
         unsigned int  error_range;

         unsigned char x_enable;
         unsigned char x_mode;
         unsigned char x_dir;
         unsigned char x_son;
         unsigned int  x_kp;
         unsigned int  x_kd;

         unsigned char y_enable;
         unsigned char y_mode;
         unsigned char y_dir;
         unsigned char y_son;
         unsigned int  y_kp;
         unsigned int  y_kd;

         unsigned char z_enable;
         unsigned char z_mode;
         unsigned char z_dir;
         unsigned char z_son;
         unsigned int  z_kp;
         unsigned int  z_kd;

         //---- information -------
         unsigned char op;
         unsigned char ip;
	 unsigned char msc;
         unsigned char sys_i;
         unsigned char ls;
         unsigned char p1;
         long          XC;
         long          XP;
         long          YC;
         long          YP;
         long          ZC;
         long          ZP;
  } CardParameter;

struct itimerval itv, oitv;		/* static int beat_nsects; next beat for seconds */
static struct sigaction act, oact;

//----- variable ------------------------------------------
CardParameter card1;
long new_z,old_z;
int  wait_count=0;
//--------------------------------------------------------------------
void set_parameter()
{
unsigned char config;

  MSERVO3_SET_NC(CARD1,NO);
  MSERVO3_SET_CONTROL_MODE(CARD1, card1.x_mode, card1.y_mode, card1.z_mode);
  MSERVO3_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP,
						card1.HSP, card1.arc_speed);
  MSERVO3_SET_DEFDIR(CARD1, card1.x_dir, card1.y_dir, card1.z_dir);
  MSERVO3_SET_SERVO_ON(CARD1, card1.x_son, card1.y_son, card1.z_son);

  config=0;
  if (card1.x_enable==ON) config |= 0x01;
  if (card1.y_enable==ON) config |= 0x02;
  if (card1.z_enable==ON) config |= 0x04;
  MSERVO3_SET_CONFIG(CARD1, config, card1.in_position, card1.lag_error, card1.error_range);

  //---- config controller
  MSERVO3_SET_X_CONTROLLER(CARD1,card1.x_kp,card1.x_kd);
  MSERVO3_SET_Y_CONTROLLER(CARD1,card1.y_kp,card1.y_kd);
  MSERVO3_SET_Z_CONTROLLER(CARD1,card1.z_kp,card1.z_kd);
}

void get_parameter()
{
int x,y;

  disable();

  //----- get card 1 information ----------------
  if (card1.exist==YES)
  {
      card1.ip  = MSERVO3_DI(CARD1);
      card1.msc = MSERVO3_MSC(CARD1);

      MSERVO3_GET_CARD(CARD1);
      card1.sys_i =MSERVO3_GET_SYS(CARD1);
      card1.ls    =MSERVO3_GET_LIMIT(CARD1);
      card1.p1    =MSERVO3_GET_P1(CARD1);
      card1.XC    =MSERVO3_GET_XC(CARD1);
      card1.XP    =MSERVO3_GET_XP(CARD1);
      card1.YC    =MSERVO3_GET_YC(CARD1);
      card1.YP    =MSERVO3_GET_YP(CARD1);
      card1.ZC    =MSERVO3_GET_ZC(CARD1);
      card1.ZP    =MSERVO3_GET_ZP(CARD1);
  }
  if (wait_count) wait_count--;

  printf("X: %6ld\tY: %6ld\tZ: %6ld\r",card1.XP, card1.YP, card1.ZP);
  enable();
}

/************************************************
 * motionTimer_handler
 *
 * routine to handle time beat
 ************************************************/
void motionTimer_handler(int sig)
{
	static i;
	get_parameter();
}


/******************************************************
 * motionTimer_init
 *
 * routine to handle time beat
 ******************************************************/
int motionTimer_init()
{
	/* set action for alarm */
	act.sa_handler = motionTimer_handler;
	sigemptyset(&act.sa_mask);
	sigaddset(&act.sa_mask, SIGALRM);
	sigaction(SIGALRM, &act, &oact);
	
	itv.it_interval.tv_sec = 0;	//second
	itv.it_interval.tv_usec = 2500;//microsecond 
	itv.it_value.tv_sec = 0;
	itv.it_value.tv_usec = 2500;
	setitimer(ITIMER_REAL, &itv, &oitv);
	
	return 0;
	
}
/******************************************
 *  motionTimer_close
 *
 *  restore original itimerval
 ******************************************/
void motionTimer_close()
{
	setitimer(ITIMER_REAL, &oitv, NULL);
	sigaction(SIGALRM, &oact, NULL);
}
//####################################################################
void main()
{
int j,error,error_count;

  disable();
  clrscr();

  //------set card 1 parameters-------------------------------------
  card1.address = 0x300;
  card1.DDA     = 1;
  card1.AD      = 50;
  card1.LSP     = 50;
  card1.HSP     = 2040; 

  card1.home_speed   = 50;
  card1.search_speed = 5;
  card1.arc_speed    = 500;
  card1.in_position  = 10;
  card1.lag_error    = 5000;
  card1.error_range  = 500;

  card1.x_enable     = ON;
  card1.x_mode       = SIMU_MODE;
  card1.x_dir        = NORMAL_DIR;
  card1.x_son        = OFF;
  card1.x_kp         = 100;
  card1.x_kd         = 0;

  card1.y_enable     = ON;
  card1.y_mode       = SIMU_MODE;
  card1.y_dir        = NORMAL_DIR;
  card1.y_son        = OFF;
  card1.y_kp         = 100;
  card1.y_kd         = 0;

  card1.z_enable     = ON;
  card1.z_mode       = SIMU_MODE;
  card1.z_dir        = NORMAL_DIR;
  card1.z_son        = OFF;
  card1.z_kp         = 100;
  card1.z_kd         = 0;

  //---- check SERVO-300 is exist or not ------------------------ 
  card1.exist=MSERVO3_REGISTRATION(CARD1, card1.address); 
  if (card1.exist!=YES)
  {
     printf("There is not exist any SERVO-300 card !\n");
     return;
  }  
  MSERVO3_RESET_SYSTEM(CARD1);  
  clrscr();

  //-------------------------------------------------------------------
  motionTimer_init();
  set_parameter();
  enable();

  printf("*** SERVO-300 ROUND-ROBIN test ***\r\n");

  //----motion command------------------------
  error=0;
  error_count=0;
  printf("\r\n");
  gotoxy(5, 8);
  printf("MSERVO3_INTP_LINE02\r\n");
  for (j=0; j<400; j++)
  {
     //------------------------------------------------
     MSERVO3_INTP_LINE02(CARD1,XY_plane, 20000,-20000, 2040, 0);
     do
     { 
	     //printf("%d full\r\n",j);
     } while (MSERVO3_INTP_STOP()!=READY);
     do {} while (MSERVO3_IS_X_STOP(CARD1)==NO);
     //---------------------------------------------
     wait_count=2;
     while(wait_count){usleep(50);}
     if ( (card1.XC!=20000) || (card1.YC!=-20000))
     {
        error=1;
        error_count++;
	printf("error x=%ld, y=%ld N=%d\r\n",card1.XP,card1.YP,j);
     };

     MSERVO3_PRESET_POSITION(CARD1,X_axis,0);
     MSERVO3_PRESET_POSITION(CARD1,Y_axis,0);
  }
  printf("\r\n");
  printf("MSERVO3_INTP_ARC02\r\n");
  for (j=0; j<400; j++)
  {
     //------------------------------------------------
     MSERVO3_INTP_ARC02(CARD1,XY_plane,20000,-20000, 100000, CW, 2040,0);
     do {} while (MSERVO3_INTP_STOP()!=READY);
     do {} while (MSERVO3_IS_X_STOP(CARD1)==NO);
     //---------------------------------------------
     wait_count=4;
     while (wait_count){usleep(50);};
     if ( (card1.XC!=20000) || (card1.YC!=-20000))
     {
        error=1;
        error_count++;
	printf("error x=%ld, y=%ld N=%d\r\n",card1.XP,card1.YP,j);
     };
     MSERVO3_PRESET_POSITION(CARD1,X_axis,0);
     MSERVO3_PRESET_POSITION(CARD1,Y_axis,0);
  }
  printf("\r\n");
  printf("MSERVO3_INTP_CIRCLE02\r\n");
  for (j=0; j<400; j++)
  {
     //------------------------------------------------
     MSERVO3_INTP_CIRCLE02(CARD1,XY_plane,10000,-10000, CW, 2040,0);
     do {} while (MSERVO3_INTP_STOP()!=READY);
     do {} while (MSERVO3_IS_X_STOP(CARD1)==NO);
     //---------------------------------------------
     wait_count=2;
     while (wait_count){usleep(500000);};
     if ( (card1.XC!=0) || (card1.YC!=0))
     {
        error=1;
        error_count++;
	printf("\nerror x=%ld, y=%ld N=%d\r\n",card1.XP,card1.YP,j);
     };
     MSERVO3_PRESET_POSITION(CARD1,X_axis,0);
     MSERVO3_PRESET_POSITION(CARD1,Y_axis,0);
  }
  printf("\nerror: %d\n", error_count);
  MSERVO3_RESET_SYSTEM(CARD1);
  motionTimer_close();
  closeDev();
}
