/* Definitions for A-628.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.1.0 16 Jan 2002 by Reed Lai
     Create. */

#ifndef _A628_H
#define _A628_H

#define MODULE_NAME "ixa628"

#define IO_RANGE       0x12

/* offset of registers */
#define AO0H		0x0
#define AO0L		0x1
#define AO1H		0x2
#define AO1L		0x3
#define AO2H		0x4
#define AO2L		0x5
#define AO3H		0x6
#define AO3L		0x7
#define AO4H		0x8
#define AO4L		0x9
#define AO5H		0xa
#define AO5L		0xb
#define AO6H		0xc
#define AO6L		0xd
#define AO7H		0xe
#define AO7L		0xf
#define DIO_A		0x10
#define DIO_B		0x11

/* mask of registers */
#define AO0H_MASK	0xf
#define AO0L_MASK	0xff
#define AO1H_MASK	0xf
#define AO1L_MASK	0xff
#define AO2H_MASK	0xf
#define AO2L_MASK	0xff
#define AO3H_MASK	0xf
#define AO3L_MASK	0xff
#define AO4H_MASK	0xf
#define AO4L_MASK	0xff
#define AO5H_MASK	0xf
#define AO5L_MASK	0xff
#define AO6H_MASK	0xf
#define AO6L_MASK	0xff
#define AO7H_MASK	0xf
#define AO7L_MASK	0xff
#define DIO_A_MASK	0xff
#define DIO_B_MASK	0xff

#endif							/* _A628_H */
