/* Definitions for DIO-24.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.1.0 16 Jan 2002 by Reed Lai
     Create. */

#ifndef _DIO24_H
#define _DIO24_H

#define MODULE_NAME "ixdio24"

#define IO_RANGE       0x10

/* offset of registers */
#define _8255_0_PORT_A          0x0
#define _8255_0_PORT_B          0x1
#define _8255_0_PORT_C          0x2
#define _8255_0_CONTROL_WORD    0x3
#define PORT_A           _8255_0_PORT_A
#define PORT_B           _8255_0_PORT_B
#define PORT_C           _8255_0_PORT_C
#define CONFIGURED_WORD  _8255_0_CONTROL_WORD
#define PA  PORT_A
#define PB  PORT_B
#define PC  PORT_C
#define CR  CONFIGURED_WORD

/* mask of registers */
#define PA_MASK    0xff
#define PB_MASK    0xff
#define PC_MASK    0xff
#define CR_MASK    0x9b

#endif							/* _DIO24_H */
