/* Definitions for DIO-48.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.1.0 16 Jan 2002 by Reed Lai
     Remove unused symbol INT_MASK_SHIFT_STOP_BIT.

   v 0.0.0 23 Jul 2001 by Reed Lai
     create, blah blah... */

#ifndef _DIO48_H
#define _DIO48_H

#define MODULE_NAME "ixdio48"

#define IO_RANGE       0x10

/* offset of registers */
#define _8255_1_PORT_A          0x0
#define _8255_1_PORT_B          0x1
#define _8255_1_PORT_C          0x2
#define _8255_1_CONTROL_WORD    0x3
#define CLEAR_INTERRUPT         0x3

#define CN1_PORT_A           _8255_1_PORT_A
#define CN1_PORT_B           _8255_1_PORT_B
#define CN1_PORT_C           _8255_1_PORT_C
#define CN1_CONFIGURED_WORD  _8255_1_CONTROL_WORD

#define CN1PA  CN1_PORT_A
#define CN1PB  CN1_PORT_B
#define CN1PC  CN1_PORT_C
#define CN1CR  CN1_CONFIGURED_WORD
#define CIR    CLEAR_INTERRUPT
#define CI     CLEAR_INTERRUPT

#define _8255_2_PORT_A          0x4
#define _8255_2_PORT_B          0x5
#define _8255_2_PORT_C          0x6
#define _8255_2_CONTROL_WORD    0x7
#define SOFT_INTERRUPT_TRIGGER  0x7

#define CN2_PORT_A           _8255_2_PORT_A
#define CN2_PORT_B           _8255_2_PORT_B
#define CN2_PORT_C           _8255_2_PORT_C
#define CN2_CONFIGURED_WORD  _8255_2_CONTROL_WORD

#define CN2PA  CN2_PORT_A
#define CN2PB  CN2_PORT_B
#define CN2PC  CN2_PORT_C
#define CN2CR  CN2_CONFIGURED_WORD
#define SIT    SOFT_INTERRUPT_TRIGGER

#define _8254_COUNTER_0         0xc
#define _8254_COUNTER_1         0xd
#define _8254_COUNTER_2         0xe
#define _8254_CONTROL_WORD      0xf

#define _8254C0  _8254_COUNTER_0
#define _8254C1  _8254_COUNTER_1
#define _8254C2  _8254_COUNTER_2
#define _8254CR  _8254_CONTROL_WORD

/* mask of registers */
#define CN1PA_MASK    0xff
#define CN1PB_MASK    0xff
#define CN1PC_MASK    0xff
#define CN1CR_MASK    0x9b
#define CIR_MASK      0xff

#define CN2PA_MASK    0xff
#define CN2PB_MASK    0xff
#define CN2PC_MASK    0xff
#define CN2CR_MASK    0x9b
#define SIT_MASK      0xff

#define _8254C0_MASK  0xff
#define _8254C1_MASK  0xff
#define _8254C2_MASK  0xff
#define _8254CR_MASK  0xff

#endif							/* _DIO48_H */
