/* Definitions for ISO-813.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */


#ifndef _ISO813_H
#define _ISO813_H

#define MODULE_NAME "ixiso813"

#define IO_RANGE       0x10

/* offset of registers */
#define ANALOG_INPUT_L                   0x04
#define ANALOG_INPUT_H                   0x05
#define AD_GAIN_CONTROL_REG              0x09
#define AD_MULTIPLEX_CONTROL_REG         0x0a
#define AD_SOFTWARE_TRIGGER_CONTROL_REG  0x0c
#define RESERVED_REG                     0x0f

#define AIL       ANALOG_INPUT_L
#define AIH       ANALOG_INPUT_H
#define ADGCR     AD_GAIN_CONTROL_REG
#define ADMXCR    AD_MULTIPLEX_CONTROL_REG
#define ADSTCR    AD_SOFTWARE_TRIGGER_CONTROL_REG

/* mask of registers */
#define AIL_MASK       0xff
#define AIH_MASK       0x1f

#define AI_READY_BIT   0x10

#define ADGCR_MASK     0xff
#define ADMXCR_MASK    0xff
#define ADSTCR_MASK    0xff

#endif							/* _ISO813_H */
