/* Definitions for ISO-LD.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */


#ifndef _ISOLD_H
#define _ISOLD_H

#define MODULE_NAME "ixisold"

#define IO_RANGE       0x10

/* offset of registers */
#define SR			0x00	// Status Byte
#define FIFO			0x04	// Data_FIFO, COMMAND_FIFO

/* Command sets */
#define CMD_READ_AD		0xa0
#define CMD_AD_SAMPLE		0xa2
#define CMD_AD_SAMPLE_INT	0xa3
#define CMD_AD_EXT		0xa4	// 
#define CMD_AD_EXT_INT		0xa5	
#define CMD_AUTO_BIAS		0x50
#define CMD_WRITE_DO		0x51
#define CMD_WRITE_DI_MODE	0x52
#define CMD_WRITE_BIAS		0x53
#define CMD_WRITE_PGA		0x54
#define CMD_CLEAR_LATCH		0x55
#define CMD_LED_ARG		0x56
#define CMD_SET_TIMER		0x57
#define CMD_READ_DI		0x90
#define CMD_READ_DO		0x91	
#define CMD_READ_DI_MODE        0x92
#define CMD_READ_BIAS		0x93
#define CMD_READ_PGA		0x94
#define CMD_READ_LATCH_DI	0x95
#define CMD_READ_BASE_DELTA	0x96
#define CMD_READ_TIMER		0x97

/* mask of registers */
#define SR_MASK   		0xff
#define FIFO_MASK     		0xff

#endif							/* _ISOLD_H */
