/* Definitions for SERVO-300.

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   *** Do not include this file in your program ***

   v 0.0.0  2 May 2003 by Reed Lai
     Bark! Bark! */

#ifndef _SERVO300_H
#define _SERVO300_H

#define MODULE_NAME        "ixservo300"
#define IO_RANGE           0x10

/* offset of registers */
#define FIFO             0x00	//write FIFO1, read FIFO2
#define DO	         0x01	//write
#define RR               0x02	//write
#define MR               0x01	//read
#define DI		 0x02	//read

/* mask of registers */
#define FIFO_MASK       0xff
#define DO_MASK         0xff
#define RR_MASK         0xff
#define MR_MASK         0xff
#define DI_MASK		0xff

int write_reg(ixisa_reg_t * reg, unsigned long int base);

#endif							/* _SERVO300_H */
