/*************************************************
 *
 *  msw.h
 * 
 *  v0.00 by Emmy Tsai
 * 
 *  Header for msw.c and mstep2.c
 *
 ************************************************/ 
#ifndef _MSW_H
#define _MSW_H

#include "ixisa.h"
#include "_step200.h"

/* for register */
#define WRFF	FIFO
#define RSTFF	RR
#define CALLBACK
#define EXPORTS
#define disable()
#define enable()

#define PHASE1 1
#define sIDLE  0

#define TEST_FIFO 0x42

#define d_DDA_cycle 10
#define d_Acc_Dec 1
#define d_Low_Speed 10
#define d_High_Speed 100

typedef struct
{
	unsigned int 	base;
	unsigned char	exist;
	unsigned char 	DDA_cycle;
	unsigned char 	Acc_Dec;
	unsigned int 	Low_Speed;
	unsigned int 	High_Speed;
}cardtype;

extern cardtype card[20];	//0-19

typedef struct
{
	unsigned char 	command;
	unsigned char 	cardNo;
	long		x;
	long 		y;
	long 		z;
	long 		R;
	unsigned char	dir;
	unsigned int 	speed;
	unsigned char	acc_mode;
}system_type;

extern system_type sys;

//extern unsigned char MSERVO3_EXIST(unsigned char);
extern void output_fifo(unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);

extern unsigned int High_Speed;
extern unsigned char WorkFlag;
extern unsigned char state;
void closeDev();


/* Macros to wrap DOS functions */
#define outportb(a, b)			(void)myoutb((unsigned int)(a), (unsigned char)(b))
#define outport(a, b)			outportb(a, b)	
#define inportb(a)			(unsigned int)myinb((unsigned int)(a))
/* FIXME - it will make some warning */
#define cprintf(x...)			printf(## x)
#define MSTEP2_REGISTRATION(a, b)	(int)MSTEP2_INIT((a), (b))
/* FIXME - gotoxy(), the fucntion of c++, not supported yet */
#define gotoxy(x, y)		//	(void)mymove(x, y) 
#define clrscr()			
#define delay(x)			usleep(x*1000)

#include "mstep2.h"
#endif			/* _MSW_H*/
